//------------------------------------------------------------------------------
// File: fvAddToRot.h
//
//
// Copyright (c) Vladimir Filippov. 2005.
//------------------------------------------------------------------------------


//////////////////////////////////////////////////////////////////////////////////////////////
//
// CfvAddToRot prototype
//
class CfvAddToRot:	public CTransInPlaceFilter,
					public IfvAddToRot,
					public ISpecifyPropertyPages,
					public CPersistStream
{
public:

    static CUnknown * WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);

    DECLARE_IUNKNOWN;
    
	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void **ppv);

	HRESULT CheckInputType(const CMediaType* mtIn);

	//  IfvAddToRot
	STDMETHODIMP get_Active(int *bActive);
	STDMETHODIMP put_Active(int bActive);

    //  ISpecifyPropertyPages
    STDMETHODIMP GetPages(CAUUID *pPages);

	// CPersistStream overrides
    HRESULT WriteToStream(IStream *pStream);
    HRESULT ReadFromStream(IStream *pStream);
    int SizeMax();
    STDMETHODIMP GetClassID(CLSID *pClsid);


	//      
	STDMETHODIMP JoinFilterGraph(IFilterGraph *pGraph, LPCWSTR pName);

	
private:

    //Constructor
    CfvAddToRot(TCHAR *tszName, LPUNKNOWN punk, HRESULT *phr);
	//Destructor
	~CfvAddToRot();

    HRESULT Transform(IMediaSample *pMediaSample);
	HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);
    
	BOOL bIsActive;
	BOOL bParamChanged;

    // Non interface locking critical section
    CCritSec m_fvLock;

};

